
/*================================================*\

	Lundi 23 novembre 1998

	Arash HABIBI

	Physique.c

      Tout ce qui concerne la couche physique

\*================================================*/

#include "Physique.h"

CouchePhys_t Phys; 

int InitCouchePhysique(char *loc, char *dist)
/*================================================*\
   Cree les sockets, les attache, et trouve 
   l'adresse de la socket distante a partir 
   du nom. La valeur rendue est le descripteur
   de la socket dont la couche liaison a besoin
   pour la fonction Attendre. 
\*================================================*/
{
  strcpy(Phys.nom_sock_loc,  loc );
  strcpy(Phys.nom_sock_dist, dist);

  Phys.desc_sock    = GetAndBindSocket(Phys.nom_sock_loc);
  Phys.adr_dist = PrepareAdresse(Phys.nom_sock_dist);
  
  return(Phys.desc_sock);
}


void StopCouchePhysique()
/*================================================*\
 ferme la socket et efface les fichiers 
 temporaires qui ont ete crees. 
\*================================================*/
{
  close(Phys.desc_sock);
  remove(Phys.nom_sock_loc);
}



int VersCouchePhysique(void *trame, int taille)
/*================================================*\
  Transmet la trame de taille (octets) vers la 
  couche physique. En realite, cette fonction 
  ecrit la trame sur la socket. 
\*================================================*/
{
  if(taille>=MAX_TRAME)
  {printf("VerCouchePhysique : La taille ");
   printf("de ce qui est envoye ne doit pas depasser %d\n",
   MAX_TRAME); return(CRASH);}

/*----------Envoyer la trame sur la socket --------*/
   else 
     if(sendto(Phys.desc_sock, trame, taille, 
	       0, (struct sockaddr*) &Phys.adr_dist, 
	       TAILLE_ADRESSE)==-1)
       {perror("VerCouchePhys sendto"); 
       return(CRASH);}
     else
       return(TOUT_BAIGNE);
}


int OrigineCouchePhysique(void *trame, int *taille)
/*================================================*\
  OrigineCouchePhysique, version type simple et structures
\*================================================*/
{
  int taille_recu, taille_adresse=TAILLE_ADRESSE; 
  
  /*--- Lire ce qui se trouve sur la socket ------------*/

  if((taille_recu = recvfrom(Phys.desc_sock, 
			     trame, MAX_TRAME, 0, 
			     (struct sockaddr *) &Phys.adr_dist,
			     &taille_adresse))<0)
    {perror("OrigineCouchePhys recvfrom"); return(CRASH);}
  
  else /* if(taille_recu>=0) */
    {
      *taille = taille_recu; 
      return(TOUT_BAIGNE);
    }
}

