
/*===============================================*\
	Mardi 3 novembre 1998

	Arash HABIBI

	SocketToolbox.c

	Prepare les sockets et les adresses. 

\*================================================*/



#include "SocketToolbox.h"

struct sockaddr_un PrepareAdresse(char *ref)
/*===============================================*\
  A partir de la reference, rend l'adresse 
  distante. 
\*===============================================*/
{
    struct sockaddr_un adresse_dist;

    adresse_dist.sun_family = AF_UNIX; 
    strcpy(adresse_dist.sun_path, ref);    

    return(adresse_dist); 
}


int GetAndBindSocket(char *ref)
/*===============================================*\
  Creee une socket et l'attache. ref est l'adresse
  de la socket locale.   Rend le descripteur vers 
  la socket. 
\*===============================================*/
{
    int desc, res; 
    struct sockaddr_un adresse_loc; 

    desc = socket(AF_UNIX, SOCK_DGRAM, 0);
    
    if(desc == -1) {perror("socket"); exit(1);}
    
/* ----- preparation de l'adresse locale ----- */
    
    adresse_loc.sun_family = AF_UNIX; 
    strcpy(adresse_loc.sun_path, ref);
    

/* ----- et attachement de la socket a   ----- */
/* ----- l'adresse ref par bind          ----- */
	
    res = bind(desc, (struct sockaddr*) &adresse_loc, 
	       sizeof(adresse_loc));
        if(res == -1) {perror(ref); exit(1);}
    
    return(desc); 
}


