/*====================================================*\

  Lundi 22 novembre 1998

  Arash Habibi

  fork.c

  Communication entre deux processus par un pipe et 
  un fork. En vue de l'implantation dans un HDLC. 

\*====================================================*/


#include <stdio.h>
#include <string.h>
#include <unistd.h>


void main(int argc, char *argv[])
{
  int pipe_pere_fils[2]; 
  int pipe_fils_pere[2]; 
  char texte_recu[50];

  if(argc!=3)
    {fprintf(stderr,"Usage : pipe_comm texte1 texte2\n");exit(1);}
  
  if(pipe(pipe_pere_fils)==-1)
    perror("pipe_pere_fils");

  if(pipe(pipe_fils_pere)==-1)
    perror("pipe_fils_pere");
  
  switch(fork())
    {
    case (pid_t) -1 : perror("fork"); exit(2); 
    case (pid_t) 0  : /* processus fils */

      if(write(pipe_fils_pere[1], argv[1], strlen(argv[1])+1)==-1)
	{perror("write_fils"); exit(1);}
      else
	fprintf(stderr,"Le texte \"%s\" de taille %d ecrit par le fils.\n", 
		argv[1], strlen(argv[1]));
      
      if(read(pipe_pere_fils[0], texte_recu, sizeof(texte_recu))==-1)
	{perror("read_fils"); exit(1);}
      else
	fprintf(stderr,"Le texte \"%s\" recu par le fils.\n", texte_recu);

      exit(0); 

    default :  /* processus pere */
      
      if(write(pipe_pere_fils[1], argv[2], strlen(argv[2])+1)==-1)
	{perror("write_pere"); exit(1);}
      else
	fprintf(stderr,"Le texte \"%s\" de taille %d ecrit par le pere.\n", 
		argv[2], strlen(argv[2]));
      
      if(read(pipe_fils_pere[0], texte_recu, sizeof(texte_recu))==-1)
	{perror("read_pere"); exit(1);}
      else
	fprintf(stderr,"Le texte \"%s\" recu par le pere.\n", texte_recu);

      exit(0);
    }
}

