
/*================================================*\

	Samedi 21 novembre 1998

	Arash HABIBI

	Emission.c

	Se contente de lancer application et liaison
	reserve des tubes pour la communication 
	entre les couches. Deux tubes pour chaque
	service. 

\*================================================*/


#include <stdio.h>
#include <string.h>
#include <unistd.h>


#include "Physique.h"

void DisconnectRequest(int **tubes)
/*================================================*\
\*================================================*/
{
  char request[1];

  if(write(tubes[DISC_AP][1], request, 1)
     <=0)
    {perror("DisconnectRequest write"); exit(1);}
}


void Application(char *FileName, int **tubes)
/*================================================*\
\*================================================*/
{
  mode_t mode; 
  int taille, ReadFile;
  char paquet[TAILLE_PAQUET];
  
  mode = S_IRUSR|S_IWUSR; 

  if((ReadFile=open(FileName, O_RDONLY, mode))==-1)
    {perror(FileName); exit(1);}

  while((taille = read(ReadFile, paquet, TAILLE_PAQUET))>0)
    if(write(tubes[DATA_AP][1], paquet, taille)<=0)
      {perror("SendData : write"); exit(1);}

  DisconnectRequest(tubes);

  close(ReadFile);
}




void main(int argc, char **argv)
/*================================================*\
\*================================================*/
{ 
  CouchePhys_t CchPhys;
  int tubes[NB_TUBES_AP][2];

  if(argc!=2)
    {printf("Usage : emetteur FichAEmettre \n");
    exit(1);}
  
  /*--------------- ouverture des tubes ----------------*/
		      
  if(pipe(tubes[CONNECT_AP])==-1)
    perror("connect_appli_phys");
  
  if(pipe(tubes[CONNECT_PA])==-1)
    perror("connect_phys_appli");
  
  if(pipe(tubes[DATA_AP])==-1)
    perror("data_appli_phys");
  
  if(pipe(tubes[DATA_PA])==-1)
    perror("data_phys_appli");
  
  if(pipe(tubes[DISC_AP])==-1)
    perror("disconnect_appli_phys");
  
  if(pipe(tubes[DISC_PA])==-1)
    perror("disconnect_phys_appli");
  

  /*--------------- separation appli-phys ----------------*/

  switch(fork())
    {
    case (pid_t) -1 : perror("fork"); exit(2); 
    case (pid_t) 0  : /* processus liaison */

      InitCouchePhys(&CchPhys, EMETTEUR, tubes);
      FreeCouchePhys(&CchPhys); break;
	
    default :  /* processus application */
	
      Application(argv[1], tubes);
    }
}
