
/*================================================*\

	Samedi 21 novembre 1998

	Arash HABIBI

	Application.c

	Tout ce qui concerne la couche application. 

\*================================================*/


#include "Application.h"


void InitCoucheAppli(CoucheAppli_t *CchAppli, int id, int conn_la, int conn_al, int data_la, int data_al, int disc_la, int disc_al)
/*================================================*\
\*================================================*/
{
  fprintf(stderr, "Couche Application %d : commence.\n", id);

  CchAppli->Conn_AL =  conn_la;
  CchAppli->Conn_LA =  conn_al;
  CchAppli->Data_AL =  data_al; 
  CchAppli->Data_LA =  data_la; 
  CchAppli->Disc_AL =  disc_al;
  CchAppli->Disc_LA =  disc_la;

  CchAppli->identite = id; 

  sprintf(CchAppli->prompt, "APPLICATION%d :) ", id);

  Appli_Boucle(CchAppli);
}


void FreeCoucheAppli(CoucheAppli_t *CchAppli)
/*================================================*\
  Ferme les fichiers et tubes; 
\*================================================*/
{
  close(CchAppli->Conn_AL);
  close(CchAppli->Conn_LA);
  close(CchAppli->Conn_LA);
  close(CchAppli->Data_AL);
  close(CchAppli->Data_LA);
  close(CchAppli->Disc_AL);
  close(CchAppli->Disc_LA); 
}


void Appli_ViderTubeInterface(int tube)
/*================================================*\
  Certains tubes n'ont pas besoin d'etre vraiment
  "lues" car leur contenu n'a pas beaucoup 
  d'importance. C'est le fait qu'il y ait un 
  message qui est important. C'est tout ce qui est 
  tube d'interface (disc, conn etc). Or si on ne 
  les lit pas, il faut tout de meme les vider, 
  sinon, la prochaine fois qu'on lira dessus, 
  les anciennes donnees y seront toujours. 
\*================================================*/
{
  char message[TAILLE_ASPI];

  if(read(tube, message, TAILLE_ASPI)<=0)
    {perror("Appli_ViderTubeInterface read"); exit(1);}
}


int Appli_OpenTerminal()
/*================================================*\
  Rend le descripteur du terminal ou sont lus
  les commandes. 
\*================================================*/
{
  int terminal; 

  terminal = open("/dev/tty", O_RDWR); 
  if(terminal == -1) {perror("/dev/tty"); exit(1);}

  return(terminal);
}


void Appli_WritePrompt(int terminal, char *prompt)
/*================================================*\
  Ecrit le prompt. 
\*================================================*/
{
  if(write(terminal, prompt, strlen(prompt)+1)==-1)
    perror("Prompt write"); 
}


int Appli_OpenFichEmis(char *nomfich)
/*================================================*\
  Rend le descripteur du fichier a envoyer. 
\*================================================*/
{
  mode_t mode; 
  int EmitFile; 

  mode = S_IRUSR|S_IWUSR; 
  
  if((EmitFile=open(nomfich, O_RDONLY, mode))==-1)
    perror(nomfich);

  return(EmitFile);
}


int Appli_OpenFichRecu(int numero)
/*================================================*\
  C'est le numero-ieme fichier de reception qu'on 
  ouvre. Il s'appellera donc FichRecu<numero>
\*================================================*/
{
  char nom[20]; 
  mode_t mode; 
  int SaveFile; 

  mode = S_IRUSR|S_IWUSR; 

  sprintf(nom, "FichRecu%d", numero);

  if((SaveFile=open(nom, O_WRONLY|O_CREAT|O_TRUNC, mode))==-1)
    perror(nom);

  return(SaveFile);
}


void Appli_Help()
/*================================================*\
\*================================================*/
{
  printf("\n");
  printf("\"envoi nomfich\" \tpour envoyer un fichier.\n");
  printf("\"dodo\" \t\t\tpour endormir la couche application.\n");
  printf("\"beep\" \t\t\tpour reveiller la couche application.\n");
  printf("\"quit\" \t\t\tpour quitter tout le programme.\n");
  printf("\n");
}


int Appli_ReceiveData(int Data_LA, int FichRecu)
/*================================================*\
  Le premier parametre est le descripteur du 
  tube de donnees liaison->appli et le deuxieme
  est le descripteur du fichier ou il faut 
  ecrire les donnees arrivees. 
  La valeur de retour est soit 1 si tout va bien
  soit -1 si tout va mal. 
\*================================================*/
{
  int taille_recu; 
  Paquet_t paquet[TAILLE_PAQUET]; 

  taille_recu = read(Data_LA, 
		     paquet, 
		     TAILLE_PAQUET);
  if(taille_recu<=0)
    {perror("Appli_ReceiveData read"); return(-1);}
  
  if(write(FichRecu,
	   paquet, 
	   taille_recu)==-1)
    {perror("Appli_ReceiveData write"); return(-1);}
  
  else return(1);
}


int Appli_EmitData(int Data_AL, int FichEmis)
/*================================================*\
  Lit un paquet sur le fichier a lire et l'envoie
  sur le tube Data_AL vers la couche liaison. 
  La valeur de retour est de 1 si la lecture 
  s'est deroulee correctement, 0 si le fichier 
  a transmettre est fini, et -1 si tout s'est 
  mal passe. 
\*================================================*/
{
  int taille_lu; 
  Paquet_t paquet[TAILLE_PAQUET]; 

  taille_lu = read(FichEmis,
		   paquet, 
		   TAILLE_PAQUET);
  if(taille_lu==-1)
    {perror("Appli_EmitData read"); return(-1);}
  
  else if(taille_lu==0)
    return(0);
  
  else if(write(Data_AL, 
		paquet, 
		taille_lu)==-1)
    {perror("Appli_EmitData write"); return(-1);}
  
  else return(1);
}


void Appli_DisconnectRequest(int Disc_AL)
/*================================================*\
  Pour dire a la couche liaison qu'il n'y a plus
  rien a emettre. 
\*================================================*/
{
  if(write(Disc_AL, REQUEST, 1)<=0)
    {perror("Appli_DisconnectRequest write"); exit(1);}
}


void Appli_DisconnectRespond(int Disc_AL)
/*================================================*\
  Simplement pour dire a la couche liaison que 
  tout est lu et qu'elle peut se deconnecter
  pour de bon. 
\*================================================*/
{
  if(write(Disc_AL, RESPOND, 1)<=0)
    {perror("Appli_DisconnectRespond write"); exit(1);}
}
  

int Appli_LectCommande(int terminal, char *nomfich)
/*================================================*\
  Rend ENVOI ou BEEP ou DODO ou QUIT avec 
  le cas echeant le deuxieme parametre dans nomfich. 
\*================================================*/
{
  int nb_arg, nb_lu;
  char ligne[100], command[50];

  nb_lu = read(terminal, ligne, 100);
  if(nb_lu==-1)
    {perror("Appli_LectCommande read"); return(-1);}
  
  nb_arg = sscanf(ligne, "%s %s", command, nomfich);

  if(nb_arg>2) 
    {printf("trop d'arguments.\n"); return(-1);}
  else if(nb_arg==-1)
    return(-1);
  else 
    {
      if(strcmp(command, "envoi")==0)
	{
	  if(nb_arg!=2)
	    fprintf(stderr,"usage : envoi <nom_fich>\n");
	  else return(ENVOI);
	}
      else if (strcmp(command, "dodo")==0) return(DODO);
      else if (strcmp(command, "beep")==0) return(BEEP);
      else if((strcmp(command, "?")==0)||
	      (strcmp(command, "help")==0)) return(HELP);
      else if(strcmp(command, "quit")==0)  return(QUIT);
      else 
	{fprintf(stderr,"Commande inconnue.\n");
	return(HELP);}
    }
}


void Appli_Boucle(CoucheAppli_t *CchAppli)
/*================================================*\
  C'est une boucle qui attend que l'on tape 
  des commandes a l'ecran, mais aussi qu'on 
  recoive des donnees ou une indication ou 
  confirmation de connexion ou de 
  deconnexion venant de la couche liaison. 
  La boucle ne s'arrete que lorsque la couche
  liaison envoie un disconnect confirm. 
\*================================================*/
{
  int terminal, FichEmis=-1, FichRecu=-1;
  int commande, res_attente, res; 
  boolean crash=FAUX, endormi = FAUX, stop=FAUX;
  char nomfich[50];

  terminal = Appli_OpenTerminal();
  Appli_WritePrompt(terminal, CchAppli->prompt);

  while((crash==FAUX)&&(stop==FAUX))
    {
      res_attente = Attendre(terminal, 
			     CchAppli->Data_LA,
			     FichEmis, 
			     CchAppli->Disc_LA,
			     0.0);

      if(res_attente==-1) crash = VRAI; 
      else
	{
	  /*-------- une commande venant du terminal ------*/

	  if(((res_attente==YaALireSur1___)||(res_attente==YaALireSur12__))||
	     ((res_attente==YaALireSur1_3_)||(res_attente==YaALireSur123_)))
	    {
	      commande = Appli_LectCommande(terminal, nomfich);

	      switch(commande)
		{
		case ENVOI : FichEmis = Appli_OpenFichEmis(nomfich); break;
		case DODO  : endormi=VRAI; break ;
		case BEEP  : endormi=FAUX; break ;
		case HELP  : Appli_Help(); break; 
		case QUIT  : Appli_DisconnectRequest(CchAppli->Disc_AL); 
		  stop=VRAI; break; 
		default    : break; 
		}
	      Appli_WritePrompt(terminal, CchAppli->prompt);
	    }

	  /*-------- une donnee venant de la couche liaison-------*/

	  if(((res_attente==YaALireSur_2__)||(res_attente==YaALireSur12__))||
	     ((res_attente==YaALireSur_23_)||(res_attente==YaALireSur123_)))
	    if(endormi==FAUX) 
	      {
		if(FichRecu==-1) FichRecu = Appli_OpenFichRecu(0);
		else
		  { 
		    res = Appli_ReceiveData(CchAppli->Data_LA, FichRecu);
		    if(res==-1) crash = VRAI; 
		    else /* tout va bien */;
		  }
	      }

	  /*-------- une donnee du fichier a emettre -------------*/

	  if(((res_attente==YaALireSur__3_)||(res_attente==YaALireSur1_3_))||
	     ((res_attente==YaALireSur_23_)||(res_attente==YaALireSur123_)))
	    if((endormi==FAUX)&&(FichEmis!=-1))
	       {
		 res = Appli_EmitData(CchAppli->Data_AL, FichEmis);
		 if(res==-1) crash=VRAI; 
		 else if(res==0) 
		   {
		     Appli_DisconnectRequest(CchAppli->Disc_AL);
		     FichEmis=-1; /* pour qu'on arrete de le lire */
		   }

		 else /* tout va bien */;
	       }
		 
	 /*--- une indication de deconnexion venant de la couche liaison---*/

	  if(res_attente==YaALireSur___4)
	    {
	      stop=VRAI;
	      Appli_ViderTubeInterface(CchAppli->Disc_LA); 
	      Appli_DisconnectRespond(CchAppli->Disc_AL);
	    }
	}
    }
  FreeCoucheAppli(CchAppli);
  fprintf(stderr, "Couche Application %d : deconnectee.\n", CchAppli->identite);
}



