
/*===============================================*\
	Mardi 3 novembre 1998

	Arash HABIBI

	Toolbox.c

	Quelques fonctions bien utiles. 

\*================================================*/


#include "Toolbox.h"


char NiemeBit(int nombre, int n)
/*================================================*\
  Rend le n-ieme bit du nombre "nombre". 
  On commence avec le bit 1 pour les unites et on 
  finit avec le bit 8 pour 128, etc. 
\*================================================*/
{
  return((nombre & (1<<(n-1)))>>(n-1)); 
}


void CheckBitABitTrame(Trame_t trame, char *comment)
/*===============================================*\
  Affiche chaque bit de la trame
\*===============================================*/
{
  printf("%s : %d : %d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d %d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d\n", 
	 comment,
	 trame, 
	 NiemeBit(trame, 32), 
	 NiemeBit(trame, 31), 
	 NiemeBit(trame, 30), 
	 NiemeBit(trame, 29),
	 NiemeBit(trame, 28), 
	 NiemeBit(trame, 27), 
	 NiemeBit(trame, 26), 
	 NiemeBit(trame, 25), 
	 NiemeBit(trame, 24), 
	 NiemeBit(trame, 23), 
	 NiemeBit(trame, 22), 
	 NiemeBit(trame, 21), 
	 NiemeBit(trame, 20), 
	 NiemeBit(trame, 19), 
	 NiemeBit(trame, 18), 
	 NiemeBit(trame, 17),

	 NiemeBit(trame, 16), 
	 NiemeBit(trame, 15), 
	 NiemeBit(trame, 14), 
	 NiemeBit(trame, 13),
	 NiemeBit(trame, 12), 
	 NiemeBit(trame, 11), 
	 NiemeBit(trame, 10), 
	 NiemeBit(trame, 9), 
	 NiemeBit(trame, 8), 
	 NiemeBit(trame, 7), 
	 NiemeBit(trame, 6), 
	 NiemeBit(trame, 5), 
	 NiemeBit(trame, 4), 
	 NiemeBit(trame, 3), 
	 NiemeBit(trame, 2), 
	 NiemeBit(trame, 1));
}


void CheckBitABitPaquet(Paquet_t paquet, char *comment)
/*===============================================*\
  Affiche chaque bit du paquet.
\*===============================================*/
{
  printf("%s : %u : %d%d%d%d%d%d%d%d\n",
	 comment,
	 paquet, 
	 NiemeBit(paquet, 8), 
	 NiemeBit(paquet, 7), 
	 NiemeBit(paquet, 6), 
	 NiemeBit(paquet, 5), 
	 NiemeBit(paquet, 4), 
	 NiemeBit(paquet, 3), 
	 NiemeBit(paquet, 2), 
	 NiemeBit(paquet, 1));
}


void SetNiemeBitTrame(Trame_t *nombre, int n, int value)
/*================================================*\
  Change le n-ieme bit pour le mettre a value
  (On commence avec le bit 1 pour les unites et 
  le bit 8 pour 128 etc. 
\*================================================*/
{
  if(value)
    *nombre = *nombre | (1<<(n-1)) ;
  else
    *nombre = *nombre & (~(1<<(n-1))) ;
}


void SetNiemeBitPaquet(char *nombre, int n, int value)
/*================================================*\
  Change le n-ieme bit pour le mettre a value
  (On commence avec le bit 1 pour les unites et 
  le bit 8 pour 128 etc. 
\*================================================*/
{
  if(value)
    *nombre = *nombre | (1<<(n-1)) ;
  else
    *nombre = *nombre & (~(1<<(n-1))) ;
}


Trame_t OuExclusif(Trame_t a, Trame_t b)
/*================================================*\
\*================================================*/
{
  return(a^b);
}



void ChangeNiemeBitTrame(Trame_t *cc, int n)
/*===============================================*\
  Change la valeur du n-ieme bit de cc 0<->1.
\*===============================================*/
{
  *cc = OuExclusif(*cc, 1<<(n-1));
}


void ChangeNiemeBitPaquet(Paquet_t *car, int n)
/*===============================================*\
  Change la valeur du n-ieme bit de car 0<->1.
\*===============================================*/
{
  *car = OuExclusif(*car, 1<<(n-1));
}


int Degre(Trame_t trame)
/*===============================================*\
  cc represente un polynome de degre au plus max. 
  Par exemple 10011. Degre donne le degre de ce 
  polynome (en l'occurrence 4)
\*===============================================*/
{
  int i, trouve=0; 

  i=8*sizeof(Trame_t); 

  if(trame==0) return(0); 
  else
    while(NiemeBit(trame, i)==0)
      i--; 

  return(i-1); 
}


Trame_t ResteDivisionModulo2(Trame_t dividende, Trame_t diviseur)
/*===============================================*\
  Fait la division modulo 2 de dividende par 
  diviseur et rend le reste. 
\*===============================================*/
{
  Trame_t dividende_interm, reste; 
  int degredvs, degredvd, i; 

  degredvs = Degre(diviseur);
  degredvd = Degre(dividende);

  dividende_interm = dividende >> (degredvd-degredvs);

  /* Soustraction en modulo2 <=> ou exclusif */
  reste = OuExclusif(dividende_interm, diviseur);

  for(i=degredvd-degredvs; i>0; i--)
    {
      dividende_interm = reste<<1; 

      /* On descend le prochain chiffre de la dividende */
      SetNiemeBitTrame(&dividende_interm, 1, NiemeBit(dividende, i)); 

      if(Degre(dividende_interm)>=degredvs) /*quotient : 1*/

	/* Soustraction par le 1 fois le diviseur */
	reste = OuExclusif(dividende_interm, diviseur);

      else
	/* Soustraction par rien  */
	reste = dividende_interm; 
    }
  return(reste);
}


void TronquerANbits(Trame_t *trame, int N)
/*===============================================*\
  Annule les bits de poids N+1, N+2, ... qui 
  peuvent perturber les calculs quand il faut 
  regarder le degre des polynomes ou alors voir 
  si le reste est nul. 
\*===============================================*/
{
  int i; 
  
  for(i=8*sizeof(Trame_t); i>N; i--)
  	SetNiemeBitTrame(trame, i, 0);
}



int Max(int n1, int n2, int n3, int n4)
/*===============================================*\
  Rend le plus grand des quatre nombres. 
\*===============================================*/
{
  int max1, max2; 

  if(n1>n2) max1 = n1;
  else max1 = n2; 
  
  if(n3>n4) max2 = n3; 
  else max2 = n4; 

  if(max1>max2) return(max1); 
  else return(max2);
}
