
/*===============================================*\
	Samedi 19 Septembre 1998

	Arash HABIBI

	ClientTCP.c

	Un espece de talk simplifie. 
	Ce cote-ci joue le role de client, 
	simplement dans le sens ou c'est lui 
	qui demande la connexion a l'autre cote.         
	Cette fois-ci, on est en mode bloquant
	et on utilise la primitive select. 

\*================================================*/


#include <sys/time.h>

#include "SocketToolbox.h"


int ConnexionClient(char *HostName, short port_dist, short port_loc)
/*===============================================*\
\*===============================================*/
{
	struct sockaddr_in adresse_loc, adresse_dist;
	int desc_sock, res, taille_adr, nb_pendants=1;  
	
/*-------- Creation et attachement de la socket du client -----*/
	
	desc_sock = GetAndBindSocket(SOCK_STREAM, port_loc, 
		&adresse_loc);
	
	printf("PapotClientTCP sur port numero %d\n",
		adresse_loc.sin_port);
		
		
/*-------- Preparation de l'adresse distante et connexion ------*/
			
	adresse_dist = WriteNetworkAddress(HostName, port_dist); 
	res = connect(desc_sock, (struct sockaddr*) &adresse_dist, 
		sizeof(adresse_dist));
	
	if(res == -1) {perror("connect"); exit(1);}
	else printf("PapotClientTCP connecte.\n");

	return(desc_sock);
}
       
  	
int Envoi(int terminal, int socket)
/*===============================================*\
  D'apres select nous savons qu'il y a 
  quelque chose a lire sur le terminal. 
  Le but de cette fonction est de lire
  ce quelque chose et de l'envoyer sur 
  la socket de service. 
  La fonction rend -1 en cas d'erreur 
  0 en cas de deconnexion et 1 si 
  tout va bien. 
\*===============================================*/
{
    int nb_lu, nb_sent;
    char message[100]; 
    
    nb_lu = read(terminal, message, 10);
    
    if(nb_lu<0) 
	{perror("read terminal"); 
	return(-1);}
    
    else if(nb_lu>0)
	{
	    nb_sent = write(socket, message, nb_lu);
	    
	    if(nb_sent<0) {perror("write socket"); 
	    return(-1);}
	    
	    else if(nb_sent==0) /* socket distante fermee */
		return(-1); /* sans crier gare ------ */
	    
	    else if(nb_sent>0) 
		if((nb_lu==2)&&
		   (strncmp(message, ".", nb_lu-1)==0))
		    return(0); 
		else
		    /* rien a faire tout va bien*/
		    return(1);
	}
}


int Reception(int terminal, int socket)
/*===============================================*\
  D'apres select nous savons qu'il y a 
  quelque chose a lire sur la socket. 
  Le but de cette fonction est de lire
  ce quelque chose et de l'envoyer sur 
  le terminal de lecture. 
  La fonction rend -1 en cas d'erreur 
  0 en cas de deconnexion et 1 si 
  tout va bien. 
\*===============================================*/
{
    int nb_ecrit, nb_rec;
    char message[100]; 
    
    nb_rec = read(socket, message, 10);
    
    if(nb_rec<0) {perror("read socket"); 
    return(-1);}
    
    else if(nb_rec==0) /* socket distante fermee */
	return(-1); 	   /* sans crier gare ------ */
    
    else if(nb_rec>0)
	{
	    if((nb_rec==2)&&
	       (strncmp(message, ".", nb_rec-1)==0))
		return(0); 	
	    else
		{
		    nb_ecrit = write(terminal, 
				     message, nb_rec);
		    
		    if(nb_ecrit<0) 
			{perror("write terminal"); 
			return(-1);}
		    
		    else if(nb_ecrit>0)
			/* rien a faire tout va bien*/
			return(1);
		}
	}
}



void main(int argc, char **argv)
/*===============================================*\
\*===============================================*/
{
	int term_rec, term_send, desc_sock;
	int transmission_over, crash; 
	int nbfds, nb_events, nb_lu, nb_recu, res;
	fd_set lecture, ecriture, except;
	 
	if(argc!=4) 
	{printf("Usage : PapotClient <hote> <port_num> <NomTerminal>\n\n"); 
	exit(1);}	

/*-------- Ouvertures diverses -------- ------------------*/

	/*-- Le terminal sur lequel on enverra -------*/

	term_send = open("/dev/tty", O_RDWR); 
	if(term_send == -1) 
	    {perror("terminal de controle"); exit(1);}

	/*-- Le terminal sur lequel on recevra -------*/

	term_rec = open(argv[3], O_RDWR); 
	if(term_rec == -1) 
	    {perror("terminal de lecture"); exit(1);}

/*-------- Connexion ------------------ ------------------*/
	
	desc_sock = ConnexionClient(argv[1], atoi(argv[2]), 0);
	transmission_over = 0; crash = 0; 
		      
/*-------- Elements permanents de select ----------------*/

	if(term_send>desc_sock) nbfds = term_send+1; 
		else nbfds = desc_sock+1; 

/*-------- La boucle d'attente d'evenement ---------------*/

	while((!crash)&&(!transmission_over))
	    {
		/*---- Preparation des ensembles -------- */
		/*--------- de descripteurs ------------- */
		
		FD_ZERO(&lecture); 
		FD_ZERO(&ecriture); 
		FD_ZERO(&except); 
		FD_SET(desc_sock, &lecture); 
		FD_SET(term_send, &lecture); 
		
		/*------- attente d'un evenment --------- */
		
		nb_events = select (nbfds, &lecture, &ecriture, 
				    &except, NULL);

		if(nb_events==-1) {perror("select"); crash=1;} 
		
		/*------- le depouillement des votes ---- */
		
		if(FD_ISSET(term_send, &lecture))
		    {
			res = Envoi(term_send, desc_sock);
			
			if(res==-1) crash=1; 
			else if(res==0) transmission_over=1; 
			else if(res>0) /* tout va bien */;
		    }
		
		if(FD_ISSET(desc_sock, &lecture))
		    {	
			res = Reception(term_rec, desc_sock);
			
			if(res==-1) crash=1; 
			else if(res==0) transmission_over=1; 
			else if(res>0) /* tout va bien */;
		    }
	    }
	close(desc_sock);
	if(crash)
		printf("Echange interrompu\n\n");
	else if(transmission_over)
		printf("Echange termine. Deconnexion.\n\n");
}
