
/*===============================================*\
	Vendredi 25 Septembre 1998

	Arash HABIBI

	ClientTCP.c

	Un programme simple qui demande une 
	connexion quelque part, qui commence
	a lui envoyer un fichier tout en 
	recevant la reponse venant du serveur. 
	Lorsqu'il a fini de transmettre, il 
	attend que la socket distante soit
	fermee pour finir. 

	(Ca pose des problemes dans le cas ou 
	la socket distante est fermee par 
	accident, et que l'emission ici est
	terminee) 

\*================================================*/


#include "SocketToolbox.h"


int ConnexionClient(char *HostName, short port_dist, short port_loc)
/*===============================================*\
\*===============================================*/
{
	struct sockaddr_in adresse_loc, adresse_dist;
	int desc_sock, res, taille_adr, nb_pendants=1;  
	
/*-------- Creation et attachement de la socket du client -----*/
	
	desc_sock = GetAndBindSocket(SOCK_STREAM, port_loc, 
		&adresse_loc);
	
	printf("Client TCP attache au port numero %d\n",
		adresse_loc.sin_port);
		
		
/*-------- Preparation de l'adresse distante et connexion ------*/
			
	adresse_dist = WriteNetworkAddress(HostName, port_dist); 
	res = connect(desc_sock, (struct sockaddr*) &adresse_dist, 
		sizeof(adresse_dist));
	
	if(res == -1) {perror("connect"); exit(1);}
	else printf("Client TCP connecte.\n");

	return(desc_sock);
}
       

int ReceptionEcriture(int desc_sock, int fich_rec)
/*===============================================*\
	Cette fonction est appelee lorsqu'il y a 
	quelque chose a lire sur la socket. La tache
	de cette fonction est de la lire et de 
	l'enregistrer dans le fichier de descripteur
	fich_rec. La fonction renvoie -1 en cas 
	d'echec, rend 1 si tout va bien.
\*===============================================*/
{
	int nb_rec, nb_ecrit; 
	char message[100], buffer[10]; 
			
	nb_rec = read(desc_sock, message, 10);
		 
	if(nb_rec<0) {perror("read socket"); return(-1);}
	
	else if (nb_rec==0) return(0);

	else if(nb_rec>0)
	{
	    	nb_ecrit = write(fich_rec, 
			message, nb_rec); 
		
		if(nb_ecrit<=0) 
		{perror("write file");
		return(-1);}
		
		else if(nb_ecrit>0) return(1);
		/* Tout va bien rien a faire */
	}
}

		    
int LectureEnvoi(int desc_sock, int fich_send)
/*===============================================*\
	Cette fonction est appelee lorsqu'il y a 
	quelque chose a lire sur le fichier de 
	descripteur fich_send. Dans ce cas, on 
	lit la suite de ce fichier et on l'envoie
	sur la socket de descripteur fich_send. 
	La fonction rend -1 en cas de probleme, 
	rend 1 si tout va bien et rend 0 lorsque
	la lecture du fichier est terminee. 
\*===============================================*/
{
	int nb_lu, nb_sent; 
	char message[100];

	nb_lu = read(fich_send, message, 10);
		 
	if(nb_lu<0) {perror("read file"); 
		return(-1);}
		
	if(nb_lu==0) return(0); 
			
	else if(nb_lu>0)
	{
		nb_sent = write(desc_sock, 
			message, nb_lu); 
				
		if(nb_sent<0) 
		{perror("write socket");
			return(-1);}
				
		else if(nb_sent>0) return(1);
		/* Tout va bien rien a faire */
	}
}


void main(int argc, char **argv)
/*===============================================*\
\*===============================================*/
{
	int fich_rec, fich_send, desc_sock; 
	int stop, crash, emission_over; 
	int nbfds, nb_events, res;
	char bidon;
	fd_set lecture, ecriture, except;
	 
	if(argc!=4) 
	{printf("Usage : client <hote> <port_num> <NomFichier>\n\n"); 
	exit(1);}	

/*-------- Ouvertures diverses ---------------------------*/

	/*----------- Le fichier qu'on enverra -------*/

	fich_send = open(argv[3], O_RDONLY); 
	if(fich_send == -1) 
	    {perror(argv[3]); exit(1);}

	/*----------- Le fichier qu'on recevra -------*/

	fich_rec = open("FichierRecu", O_WRONLY|O_CREAT|O_TRUNC); 
	if(fich_rec == -1) 
	    {perror("FichierRecu"); exit(1);}
	    

/*-------- Connexion ------------------ ------------------*/
	
	desc_sock = ConnexionClient(argv[1], atoi(argv[2]), 0);
	emission_over=0; stop=0; crash = 0; 
				
/*-------- Elements permanents de select ----------------*/
    
	nbfds = desc_sock + 1;  
		
/*-------- Boucle de lecture-ecritue ---------------------*/

    while((!crash)&&(!stop))
	{
	    /*---- Preparation des ensembles -------- */
	    /*--------- de descripteurs ------------- */
	    
	    FD_ZERO(&lecture); 
	    FD_ZERO(&ecriture); 
	    FD_ZERO(&except); 
	    FD_SET(desc_sock, &lecture); 
	    FD_SET(desc_sock, &ecriture); 
	    
	    /*------- attente d'un evenment --------- */
	    
	    nb_events = select (nbfds, &lecture, &ecriture, 
				&except, NULL);
	    
	    if(nb_events==-1) {perror("select"); crash=1;} 
	    
	    /*------- le depouillement des votes ---- */
	    
	    if(FD_ISSET(desc_sock, &lecture))
		{
		    res = ReceptionEcriture(desc_sock, 
				  fich_rec);
				  
		    if(res==0) 
		    	if(emission_over) 
			{ 	printf("socket distante deconnectee.\n");
				stop=1; }
			else 
			{ 	printf("socket distante disparue sans preavis\n");
				crash=1; }
		    else if(res<0) crash=1; 
		    else if(res>0) /* tout va bien */;
		}
	    
	 if((!emission_over)&&(FD_ISSET(desc_sock, &ecriture)))	
	        {	
		    res = LectureEnvoi(desc_sock, fich_send);
		    
		    if(res==0) {emission_over=1; 
		    printf("\nEmission over\n\n");}
		    else if(res<=0) crash=1; 
		    else if(res>0) /* tout va bien */;
		}
	}

	close(desc_sock);
	close(fich_send); 
	close(fich_rec);
	
	if(crash)
		printf("Echange interrompu\n\n");
	else 
		printf("Echange termine. Deconnexion.\n\n");
}
